﻿namespace Ggd.Splorr.Gadabout.MGClient

open Ggd.Splorr.Gadabout

module DisplayColors =
    open Microsoft.Xna.Framework

    let private colors =
        [(Hue.Onyx,(0x20, 0x20, 0x20, 0xFF));
        (Hue.Carnelian,(0x80, 0x20, 0x20, 0xFF));
        (Hue.Copper,(0x80, 0x40, 0x20, 0xFF));
        (Hue.Gold,(0x80, 0x80, 0x20, 0xFF));
        (Hue.Jade,(0x20, 0x80, 0x20, 0xFF));
        (Hue.Turquoise,(0x20, 0x80, 0x80, 0xFF));
        (Hue.Ruby,(0x20, 0x50, 0x80, 0xFF));
        (Hue.Amethyst,(0x80, 0x20, 0x80, 0xFF));
        (Hue.Silver,(0x80, 0x80, 0x80, 0xFF));
        (Hue.MediumCarnelian,(0x68, 0x20, 0x20, 0xFF));
        (Hue.MediumCopper,(0x68, 0x38, 0x20, 0xFF));
        (Hue.MediumGold,(0x68, 0x68, 0x20, 0xFF));
        (Hue.MediumJade,(0x20, 0x68, 0x20, 0xFF));
        (Hue.MediumTurquoise,(0x20, 0x68, 0x68, 0xFF));
        (Hue.MediumRuby,(0x20, 0x44, 0x68, 0xFF));
        (Hue.MediumAmethyst,(0x68, 0x20, 0x68, 0xFF));
        (Hue.MediumSilver,(0x68, 0x68, 0x68, 0xFF));
        (Hue.DarkCarnelian,(0x50, 0x20, 0x20, 0xFF));
        (Hue.DarkCopper,(0x50, 0x30, 0x20, 0xFF));
        (Hue.DarkGold,(0x50, 0x50, 0x20, 0xFF));
        (Hue.DarkJade,(0x20, 0x50, 0x20, 0xFF));
        (Hue.DarkTurquoise,(0x20, 0x50, 0x50, 0xFF));
        (Hue.DarkRuby,(0x20, 0x38, 0x50, 0xFF));
        (Hue.DarkAmethyst,(0x50, 0x20, 0x50, 0xFF));
        (Hue.DarkSilver,(0x50, 0x50, 0x50, 0xFF));
        (Hue.DarkerCarnelian,(0x38, 0x20, 0x20, 0xFF));
        (Hue.DarkerCopper,(0x38, 0x28, 0x20, 0xFF));
        (Hue.DarkerGold,(0x38, 0x38, 0x20, 0xFF));
        (Hue.DarkerJade,(0x20, 0x38, 0x20, 0xFF));
        (Hue.DarkerTurquoise,(0x20, 0x38, 0x38, 0xFF));
        (Hue.DarkerRuby,(0x20, 0x2C, 0x38, 0xFF));
        (Hue.DarkerAmethyst,(0x38, 0x20, 0x38, 0xFF));
        (Hue.DarkerSilver,(0x38, 0x38, 0x38, 0xFF));
        (Hue.UIEnabled,(0xFF, 0xFF, 0xFF, 0xFF));
        (Hue.UIDisabled,(0xC0, 0xC0, 0xC0, 0xFF));
        (Hue.SuperLight,(0xFF, 0xCC, 0x88, 0xFF));
        (Hue.Lightest,(0xF0, 0xC0, 0x80, 0xFF));
        (Hue.Lighter,(0xE1, 0xB4, 0x78, 0xFF));
        (Hue.Light,(0xD2, 0xA8, 0x70, 0xFF));
        (Hue.MediumLight,(0xC3, 0x9C, 0x68, 0xFF));
        (Hue.Medium,(0xB4, 0x90, 0x60, 0xFF));
        (Hue.MediumDark,(0xA5, 0x84, 0x58, 0xFF));
        (Hue.Dark,(0x96, 0x78, 0x50, 0xFF));
        (Hue.Darker,(0x87, 0x6C, 0x48, 0xFF));
        (Hue.Darkest,(0x78, 0x60, 0x40, 0xFF));
        (Hue.SuperDark,(0x69, 0x54, 0x38, 0xFF))]
        |> Map.ofList
        |> Map.map (fun _ (r,g,b,a) -> new Color(r,g,b,a))

    let getColor (hue:Hue) =
        colors.[hue]

